var MouseOverCore, MoveStartCore, MoveEndCore, CoreToEdit, PageNo, PageMode, SoundMode, ClockMode, GridMode;
var CopyIcon, CopyPath, CopyDesc, CopyPara, ClockColorCode ,BackgroundColorCode, GridColorCode, PageColorCode;

function widgetOnLoad()
{
      button1.Text = getinivalue(WidgetPath+"config.ini","Default","button1.Text","");
      button2.Text = getinivalue(WidgetPath+"config.ini","Default","button2.Text","");
      button3.Text = getinivalue(WidgetPath+"config.ini","Default","button3.Text","");
      button4.Text = getinivalue(WidgetPath+"config.ini","Default","button4.Text","");
      button5.Text = getinivalue(WidgetPath+"config.ini","Default","button5.Text","");
      ClockColorCode = getinivalue(Widgetpath+"config.ini","Default","ClockColorCode",rgba(255,0,0,255));
      BackgroundColorCode = getinivalue(Widgetpath+"config.ini","Default","BackgroundColorCode",rgba(0,0,0,255));
      GridColorCode = getinivalue(Widgetpath+"config.ini","Default","GridColorCode",rgba(0,0,0,255));
      PageColorCode = getinivalue(Widgetpath+"config.ini","Default","PageColorCode",rgba(0,0,0,255));
      PageNo = getinivalue(WidgetPath+"config.ini","Default","PageNo","");
      PageMode = getinivalue(WidgetPath+"config.ini","Default","PageMode","");
      SoundMode = getinivalue(WidgetPath+"config.ini","Default","SoundMode","");
      ClockMode = getinivalue(WidgetPath+"config.ini","Default","ClockMode","");
      GridMode = getinivalue(WidgetPath+"config.ini","Default","GridMode","");
      ShowClock();
      BackgroundColorChange();
      GridColorChange();
      PageColorChange();
      GridLinesOnOff();
      ShowPage();
      windowZPosition = 2;  // window position always keep top most
}                                          

function OnMouseEnter(control)
{
     eval(control.name).Border.Color = rgba(255,0,0,255);
     MouseOverCore = "shortcut" + control.name;
}

function OnMouseLeave(control)
{
     eval(control.name).Border.Color = GridColorCode;
}


function OnMouseDown(Sender,Button,Shift,X,Y)
{
    if(Button == 0)                       // if left mouse button down
    {
    MoveStartCore = MouseOverCore;        // set the core to start the move
    }
    if(Button == 1)                       // if right mouse button down
    {
    CoreToEdit = MouseOverCore;           // set the core to copy/paste or delete 
    }
    if(SoundMode == 1)                    // if sound is enabled
    {
    PlaySound("click.wav");               // play click sound
    }
}                                                        

function OnMouseUp(Sender,Button,Shift,X,Y)
{
    if(Button == 0)                     
    {
    setTimeout("MoveShortcut()", 0010); 
    }
}

function MoveShortcut()
{
    MoveEndCore = MouseOverCore;       

    if(MoveStartCore != MoveEndCore && eval(MoveEndCore).path == "")   
    {                                                                  
      var StartIcon = "!SetIcon=" + eval(MoveStartCore).icon;
      eval(MoveEndCore).cmd(null, StartIcon);     
      
      var StartPath = "!SetPath=" + eval(MoveStartCore).path;
      eval(MoveEndCore).cmd(null, StartPath);     

      var StartDesc =  eval(MoveStartCore).displayName;   
      eval(MoveEndCore).displayName = StartDesc;         
      Setvalue(MoveEndCore + ".displayName",StartDesc);      
      
      if(eval(MoveStartCore).param != "")           
      {
      var StartPara =  eval(MoveStartCore).param;
      eval(MoveEndCore).param = StartPara;        
      Setvalue(MoveEndCore + ".param",StartPara);  
      eval(MoveStartCore).param = ""               
      Setvalue(MoveStartCore + ".param","");      
      }
      
      eval(MoveStartCore).cmd(null, "!SetIcon=blank.png" );  
      eval(MoveStartCore).cmd(null, "!SetPath=" );          
      SaveChanges();     
    }
}

function CopyShortcutOnClick(Sender)    
{
      CopyIcon = "!SetIcon=" + eval(CoreToEdit).icon;
      CopyPath = "!SetPath=" + eval(CoreToEdit).path;
      CopyDesc =  eval(CoreToEdit).displayName;
      CopyPara =  eval(CoreToEdit).param;
}

function PasteShortcutOnClick(Sender)   
{
      if(eval(CoreToEdit).path == "")   
      {
      eval(CoreToEdit).cmd(null, CopyIcon);     
      eval(CoreToEdit).cmd(null, CopyPath);     
      eval(CoreToEdit).displayName = CopyDesc;  
      Setvalue(CoreToEdit + ".displayName",CopyDesc);    
      eval(CoreToEdit).param = CopyPara;          
      Setvalue(CoreToEdit + ".param",CopyPara);    
      }
      else
      {
      windowZPosition = 0;
      alert("Paste location is not empty");
      windowZPosition = 2;
      }
}

function AddShortcutOnClick(Sender)     
{
      if(eval(CoreToEdit).path == "")   
      {
      windowZPosition = 0;
      eval(CoreToEdit).cmd(null, "!ShowSetting" );
      windowZPosition = 2;
      }
      else
      {
      windowZPosition = 0;
      alert("Add location is not empty");
      windowZPosition = 2;
      }
}

function EditShortcutOnClick(Sender)    
{
      windowZPosition = 0;
      eval(CoreToEdit).cmd(null, "!ShowSetting" );
      windowZPosition = 2;
}

function DeleteOnClick(Sender)     
{
       eval(CoreToEdit).cmd(null, "!SetIcon=blank.png" );  
       eval(CoreToEdit).cmd(null, "!SetPath=" );           
       eval(CoreToEdit).param = ""               
       Setvalue(CoreToEdit + ".param","");       
       SaveChanges();
}

function OnPageButtonEnter(Sender)
{
      if (PageMode == 1)                           
      {
      var MouseOverPageButton = Sender.name;       
      var GoToPage = MouseOverPageButton + "OnClick()";
      eval(GoToPage);                             
      }
}

function button1OnClick(Sender)       
{
       PageNo = 1;
       ShowPage();
       PageFlipSoundEffect()
}

function button2OnClick(Sender)       
{
       PageNo = 2;
       ShowPage();
       PageFlipSoundEffect()
}

function button3OnClick(Sender)     
{
       PageNo = 3;
       ShowPage();
       PageFlipSoundEffect()
}

function button4OnClick(Sender)     
{
       PageNo = 4;
       ShowPage();
       PageFlipSoundEffect()
}

function button5OnClick(Sender)     
{
       PageNo = 5;
       ShowPage();
       PageFlipSoundEffect()
}

function SaveChanges()
{
       SaveAsDefIni();
}

function PageTitle1OnClick(Sender)   
{
      windowZPosition = 0;
      var UserInput=prompt("Enter title for page 1",button1.Text);
      button1.Text = UserInput;
      Setvalue("button1.Text",UserInput);   
      windowZPosition = 2;
      SaveChanges();
}

function PageTitle2OnClick(Sender)  
{
      windowZPosition = 0;
      var UserInput=prompt("Enter title for page 2",button2.Text);
      button2.Text = UserInput;
      Setvalue("button2.Text",UserInput);   
      windowZPosition = 2;
      SaveChanges();
}

function PageTitle3OnClick(Sender)  
{
      windowZPosition = 0;
      var UserInput=prompt("Enter title for page 3",button3.Text);
      button3.Text = UserInput;
      Setvalue("button3.Text",UserInput);  
      windowZPosition = 2;
      SaveChanges();
}

function PageTitle4OnClick(Sender)  
{
      windowZPosition = 0;
      var UserInput=prompt("Enter title for page 4",button4.Text);
      button4.Text = UserInput;
      Setvalue("button4.Text",UserInput);  
      windowZPosition = 2;
      SaveChanges();
}

function PageTitle5OnClick(Sender)  
{
      windowZPosition = 0;
      var UserInput=prompt("Enter title for page 5",button5.Text);
      button5.Text = UserInput;
      Setvalue("button5.Text",UserInput);   
      windowZPosition = 2;
      SaveChanges();
}

function SoundModeOnClick(Sender)  
{
      windowZPosition = 0;
      var UserInput=confirm("Click OK to enable sound effects." + "\n" + "Click Cancel to disable sound effects.");
      if (UserInput == true)
      {
      SoundMode = 1;
      }
      else
      {
      SoundMode = 0;
      }

      Setvalue("SoundMode",SoundMode);     
      windowZPosition = 2;
}

function PageFlipSoundEffect()
{
      if(SoundMode == 1)              
      {
      PlaySound("flip.wav");              // play flip sound
      }
}

function PageModeOnClick(Sender)    // called from menus
{
      windowZPosition = 0;
      var UserInput=confirm("Click OK for pages to change without clicking the button." + "\n" + "Click Cancel for pages to change after button click.");
      if (UserInput == true)
      {
      PageMode = 1;
      }
      else
      {
      PageMode = 0;
      }

      Setvalue("PageMode",PageMode);  
      windowZPosition = 2;
}

function ShowPage()    
{
       AllLayersOff();
       var LayerOn = "layer" + PageNo;
       eval(LayerOn).visible = true;
       AllButtonEffectsOff();
       var ButtonOn = "button" + PageNo;
       eval(ButtonOn).Effect.InnerShadow.Enabled = 0;
       Setvalue("PageNo",PageNo);           
}

function AllLayersOff()
{
       layer1.visible = false;
       layer2.visible = false;
       layer3.visible = false;
       layer4.visible = false;
       layer5.visible = false;
}

function AllButtonEffectsOff()
{
       button1.Effect.InnerShadow.Enabled = 1;
       button2.Effect.InnerShadow.Enabled = 1;
       button3.Effect.InnerShadow.Enabled = 1;
       button4.Effect.InnerShadow.Enabled = 1;
       button5.Effect.InnerShadow.Enabled = 1;
}

function ClockModeOnClick(Sender)  
{
      windowZPosition = 0;
      var UserInput=confirm("Click OK to show the Time & Date." + "\n" + "Click Cancel to hide the Time & Date.");
      if (UserInput == true)
      {
      ClockMode = 1;
      }
      else
      {
      ClockMode = 0;
      }

      Setvalue("ClockMode",ClockMode);     
      windowZPosition = 2;
      SaveChanges();
      ShowClock();
}

function ClockTextColor()  
{
      windowZPosition = 0;
      ClockColorCode = SelectColor(ClockColorCode);   
      SetValue("ClockColorCode",ClockColorCode);     
      windowZPosition = 2;
      ShowClock();
      SaveChanges();
}

function ShowClock()
{
      text0.font.fill.color = ClockColorCode; 
      if (ClockMode == 1)                    
      {
      layer0.visible = true;                
      }
      else
      {
      layer0.visible = false;
      }
}

function GridModeOnClick(Sender)   
{
      windowZPosition = 0;
      var UserInput=confirm("Click OK to show the Grid." + "\n" + "Click Cancel to hide the Grid.");
      if (UserInput == true)
      {
      GridMode = 1;
      }
      else
      {
      GridMode = 0;
      }

      Setvalue("GridMode",GridMode);       
      windowZPosition = 2;
      SaveChanges();
      GridLinesOnOff();
}

function GridLinesOnOff()       
{
      for (var p=0; p<5; p++)       
      {
          for (var b=1; b<61; b++)     
          {
              var i = p*100+b;          
              eval("core" + i).Border.Enabled = eval(GridMode);
          }
      }
}

function AllBackgroundColor()        
{
      windowZPosition = 0;
      BackgroundColorCode = SelectColor(BackgroundColorCode);    
      SetValue("BackgroundColorCode",BackgroundColorCode);
      windowZPosition = 2;
      BackgroundColorChange();
      SaveChanges();
}

function BackgroundColorChange()   
{
      layer0.Background.SolidColor.Color = BackgroundColorCode;
      layer1.Background.SolidColor.Color = BackgroundColorCode;
      layer2.Background.SolidColor.Color = BackgroundColorCode;
      layer3.Background.SolidColor.Color = BackgroundColorCode;
      layer4.Background.SolidColor.Color = BackgroundColorCode;
      layer5.Background.SolidColor.Color = BackgroundColorCode;
      SaveChanges();
}

function AllGridColor()         
{
      windowZPosition = 0;
      GridColorCode= SelectColor(GridColorCode);   
      SetValue("GridColorCode",GridColorCode);
      windowZPosition = 2;
      GridColorChange();
      SaveChanges();
}

function GridColorChange()  
{
      for (var p=0; p<5; p++)      
      {
          for (var b=1; b<61; b++)      
          {
              var i = p*100+b;          
              eval("core" + i).Border.Color = GridColorCode;             
          }
      }
}

function PageColor()         
{
      windowZPosition = 0;
      PageColorCode = SelectColor(PageColorCode);    
      SetValue("PageColorCode",PageColorCode);
      windowZPosition = 2;
      PageColorChange();
      SaveChanges();
}

function PageColorChange()  
{
      imageP1.Background.SolidColor.Color = PageColorCode;
      imageP2.Background.SolidColor.Color = PageColorCode;
      imageP3.Background.SolidColor.Color = PageColorCode;
      imageP4.Background.SolidColor.Color = PageColorCode;
      imageP5.Background.SolidColor.Color = PageColorCode;
      SaveChanges();
}

function recyclebincore1OnUpdate(Sender) 
{
      for (var p=0; p<5; p++)      
      {
          for (var b=1; b<61; b++)      
          {
              var i = p*100+b;           
              if (eval("shortcutcore" + i).path == "recyclebin" && recyclebincore1.items == 0) 
              {
              eval("shortcutcore" + i).cmd(null, "!SetIcon=recycleMT.png" );
              }
              if (eval("shortcutcore" + i).path == "recyclebin" && recyclebincore1.items > 0) 
              {
              eval("shortcutcore" + i).cmd(null, "!SetIcon=recycleNMT.png" );
              }
          }
      }
}
